## metview 5.3.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
#
#  Metview-specific:
#  -DMETVIEW_SITE=ecmwf | other
#  -DMETVIEW_SCRIPT=name-of-generated-startup-script
#  -DMARS_HOME=/path/to/MARS/home  (requires WITH_MARS=ON)
#  -DMAGICS_PATH=/path/to/magics   (requires WITH_PLOTTING=ON)
#  -DEXTRA_TITLE=extra-title-string
#  -DLOG_DIR=/path/to/dir/for/module/log/files
#  -DODB1_USE_SCRIPT_PATH=/path/to/odb1/use/script

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( metview C CXX )


# All executables and scripts apart from the startup script should go into MV_BIN_DIR.
# Users can override by setting METVIEW_INSTALL_EXE_BIN_DIR.
# It should be relative to the root of the install directory.
if(DEFINED METVIEW_INSTALL_EXE_BIN_DIR)
    set(MV_BIN_DIR ${METVIEW_INSTALL_EXE_BIN_DIR})
else()
    set(MV_BIN_DIR bin/metview_bin)
endif()


set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)

set(INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

include( ecbuild_system NO_POLICY_SCOPE )

IF(APPLE)
  SET(MACOSX_RPATH 1)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
ENDIF(APPLE)

ecbuild_requires_macro_version( 1.9 )

ecbuild_add_cxx11_flags()  # Magics 3 requires C++11/14


###############################################################################
# some options of this project

option( ENABLE_UI             "enable the user interface"                          ON )
option( ENABLE_PLOTTING       "enable the plotting module"                         ON )
option( ENABLE_OPERA_RADAR    "enable OPERA radar filter module (requires proj4)"  AUTO )
option( ENABLE_MARS           "enable MARS access"                                 OFF )
option( ENABLE_ODB            "enable ODB"                                         OFF )
option( ENABLE_MARS_ODB       "enable ODB in MARS"                                 OFF )
option( ENABLE_USAGE_LOG      "enable usage logging (only at ECMWF)"               OFF )
option( ENABLE_QT_DEBUG       "enable Qt debugging messages"                       OFF )
option( ENABLE_INPE           "enable INPE modules"                                OFF )
option( ENABLE_URL_DOWNLOAD   "enable downloading of files from URLs"              ON )
option( ENABLE_WEATHER_ROOM   "enable Weather Room plot export (only at ECMWF)"    OFF )
option( ENABLE_SHARE_PLOT     "enable sharing of plots (only at ECMWF)"            OFF )
option( ENABLE_SHARE_TO_GLOBE "enable Globe plot export (only at ECMWF)"           OFF )
option( ENABLE_NETWORK_PROXY  "enable network proxy settings for WMS"              OFF )
option( ENABLE_EXPERIMENTAL   "enable experimental modules"                        OFF )
option( ENABLE_CONTRIB        "enable externally contributed modules"              OFF )
option( ENABLE_FORTRAN        "enable modules which use Fortran code"              ON )

ecbuild_add_option( FEATURE PPROC_MIR
    DESCRIPTION "compile with MIR interpolation"
    DEFAULT ON
    REQUIRED_PACKAGES "PROJECT mir" )

if( HAVE_PPROC_MIR )
    ecbuild_add_cxx11_flags()
    list( APPEND MARS_FEATURE_LIBRARIES mir )
endif()

ecbuild_add_option( FEATURE PPROC_EMOS
    DESCRIPTION "compile with EMOSLIB interpolation"
    DEFAULT ON
    REQUIRED_PACKAGES "PROJECT libemos" )

if( HAVE_PPROC_EMOS )
    list( APPEND MARS_FEATURE_LIBRARIES emos )
endif()


if( NOT HAVE_PPROC_MIR AND NOT HAVE_PPROC_EMOS  )
    message( FATAL_ERROR "MARS client requires PPROC (for which MIR or EMOSLIB is required)" )
endif()


###############################################################################


if( ENABLE_FORTRAN )
    ecbuild_enable_fortran( REQUIRED )
    set(HAVE_FORTRAN 1)
endif()


# ensure we can add non-existent dependencies - required for generating icon files
if( ${CMAKE_VERSION} VERSION_GREATER "2.9.9" )
    cmake_policy(SET CMP0046 OLD)
endif()



# if we don't explicitly state that we're at ECMWF, then assume we're not, and use the generic config
if(NOT METVIEW_SITE STREQUAL ecmwf)
    set( SITE_WMO_CODE "255")    # DO WE NEED AN OPTION TO ALLOW INSTALLERS TO SPECIFY THIS?
    set( MV_ENVIRON    "common")
    set( AT_ECMWF "FALSE" )
    ecbuild_info("Building outside ECMWF")
else()
    set( SITE_WMO_CODE "098")
    set( MV_ENVIRON    "ecm_lnx64")
    set( AT_ECMWF "TRUE" )
    add_definitions( -DECMWF )
    ecbuild_info("Building inside ECMWF")
endif()


if(DEFINED EXTRA_CONFIG_PATH)
    ecbuild_info("Will search ${EXTRA_CONFIG_PATH} for additional config files")
endif()



# default startup script name
if(NOT DEFINED METVIEW_SCRIPT )
    set( METVIEW_SCRIPT "metview" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${METVIEW_SCRIPT})

# ensure we don't build shared libraries
set(BUILD_SHARED_LIBS OFF)


# Weather Room plot export (ECMWF only)
if(ENABLE_WEATHER_ROOM)
    if(AT_ECMWF)
        ecbuild_add_extra_search_paths( boost ) # Weather Room export needs Boost
        find_package( Boost 1.49.0 )            # Weather Room export needs Boost
        set(MV_WEATHER_ROOM_BUILT true)
    else()
        ecbuild_error("ENABLE_WEATHER_ROOM only available when building at ECMWF")
    endif()
else()
    set(MV_WEATHER_ROOM_BUILT false)
endif()

# Globe plot export (ECMWF only)
if(ENABLE_SHARE_TO_GLOBE)
    if(NOT AT_ECMWF)
        ecbuild_error("ENABLE_SHARE_TO_GLOBE only available when building at ECMWF")
    endif()
    if(NOT ENABLE_SHARE_PLOT)
        ecbuild_error("ENABLE_SHARE_TO_GLOBE only available when ENABLE_SHARE_PLOT is enabled")
    endif()
endif()

if(ENABLE_INPE)
    set(METVIEW_INPE true)
endif()


# --------------------------------
# look for MARS client source code
# --------------------------------

if(MARS_SOURCE_PATH)
    # if the user specified a path, then only look there
    set(MARS_SOURCE_PATHS ${MARS_SOURCE_PATH}/src)
else()
    # otherwise look in some default locations
    set(MARS_SOURCE_PATHS ${CMAKE_SOURCE_DIR}/src/libMars         # embedded in source
                          ${CMAKE_SOURCE_DIR}/src/libMarsClient   # embedded in source
                          ${CMAKE_SOURCE_DIR}/mars-client/src     # bundle
                          ${CMAKE_SOURCE_DIR}/mars_client/src     # bundle
                          ${CMAKE_SOURCE_DIR}/../client/src       # in external dir
                          ${CMAKE_SOURCE_DIR}/../mars-client/src  # in external dir
                          ${CMAKE_SOURCE_DIR}/../mars_client/src) # in external dir
endif()

ecbuild_debug("Looking for MARS source in ${MARS_SOURCE_PATHS}")
find_path( MARS_SOURCE request.c
           HINTS ${MARS_SOURCE_PATHS}
           PATH_SUFFIXES src
           DOC "Path to MARS client source code"
           NO_DEFAULT_PATH )

if (MARS_SOURCE)
    ecbuild_info("Found MARS source at ${MARS_SOURCE}")
else()
    ecbuild_critical("MARS source is required, but was not found in  ${MARS_SOURCE_PATHS}")
endif()


# ensure the MARS client source is included in the tarball (if necessary)
if(NOT ${MARS_SOURCE} STREQUAL ${CMAKE_SOURCE_DIR}/src/libMars)
    list( APPEND CPACK_SOURCE_INSTALLED_DIRECTORIES
            "${MARS_SOURCE}" "src/libMarsClient")
endif()



# look for curl because it is needed for the Mars Web API client
find_package(CURL)

# we require rpcgen for MARS
find_package(RPCGEN)
if(NOT RPCGEN_FOUND)
    ecbuild_critical("Executable rpcgen was not found - please install it.")
endif()

find_package(RPC)
if(NOT RPC_FOUND)
    ecbuild_critical("Library or headers for rpc not found - please install it; try libtirpc-devel")
endif()



# local MARS access
if(ENABLE_MARS)
    set( MARS_ACCESS MARS_local )
    set( METVIEW_MARS 1 )
    if(DEFINED MARS_LOCAL_HOME)
        ecbuild_info("MARS_LOCAL_HOME=${MARS_LOCAL_HOME}")
        if(NOT EXISTS ${MARS_LOCAL_HOME})
            ecbuild_critical("MARS_LOCAL_HOME (${MARS_LOCAL_HOME}) does not exist")
        else()
            set(MARS_HOME ${MARS_LOCAL_HOME})
        endif()
    else()
        ecbuild_critical("If setting local MARS access, -DMARS_LOCAL_HOME=/path/to/mars/home must be provided.")
    endif()


    # FDB
    ecbuild_add_option( FEATURE FDB5
        DEFAULT OFF
        DESCRIPTION "support for FDB5"
        REQUIRED_PACKAGES "PROJECT mars-server VERSION 7.7" )


    # Note that in order for Metview's Python interface to work,
    # we need a shared version of the FDB library. When building at ECMWF
    # we can ensure that this is the case. Normally, users outside
    # of ECMWF will not need the FDB library at all.
    if(AT_ECMWF)
        ecbuild_use_package( PROJECT FDB REQUIRED )
    else()
        ecbuild_use_package( PROJECT FDB )
    endif()

    ecbuild_debug("FDB: ${FDB_LIBRARIES}")

    if( NOT FDB_FOUND )
        ecbuild_info("NO FDB")
    endif()


    if(ENABLE_MARS_ODB)
        set(ENABLE_ODB 1)
        set(METVIEW_MARS_ODB 1)
    endif()

    #find_library( FDB  REQUIRED )
    #ecbuild_debug("FDB: ${FDB_LIBRARIES}" )

else()
    if(${CURL_FOUND})
        set( MARS_ACCESS MARS_webapi )
    else()
        set( MARS_ACCESS MARS_none )
        add_definitions(-DNOCURL)
        ecbuild_warn("Could not find the Curl library - disabling Web API Mars")
    endif()
endif()


# Network access (download via URLs)
if(ENABLE_URL_DOWNLOAD)
    if(NOT CURL_FOUND)
        ecbuild_critical("URL_DOWNLOAD was enabled, but the 'curl' development package was not found.")
    endif()
endif()




###############################################################################
# local project requirements

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )



ecbuild_use_package( PROJECT eccodes VERSION 2.4.0 REQUIRED
                     FAILURE_MSG "ecCodes is required in order to build Metview. Note that GRIB_API is no longer supported in Metview" )

set( GRIB_API_INCLUDE_DIRS  ${ECCODES_INCLUDE_DIRS} )
set( GRIB_API_LIBRARIES     ${ECCODES_LIBRARIES} )
set( GRIB_API_DEFINITIONS   ${ECCODES_DEFINITIONS} )
set( GRIB_API_TPL_LIBRARIES ${ECCODES_TPL_LIBRARIES} )
set( grib_api_BASE_DIR      ${eccodes_BASE_DIR} )
add_definitions(-DGRIB_HANDLING_PACKAGE=ecCodes)


if(ENABLE_ODB)
    ecbuild_use_package( PROJECT odb_api  VERSION 0.10.1 ) # requires at least this version
    if( ODB_API_FOUND )

        set( METVIEW_ODB_API_LIBRARIES Odb )
        # does this version use eckit?
        list(FIND ODB_API_LIBRARIES eckit ODB_ECKIT_INDEX)


        if ((NOT ODB_ECKIT_INDEX EQUAL -1) OR (DEFINED ODB_ECKIT))  # is an eckit version
            if (DEFINED SEPARATE_ECKIT)
                ecbuild_use_package( PROJECT eckit VERSION 0.6 REQUIRED )
            endif()
            add_definitions(-DODB_ECKIT)
        endif()

        set(METVIEW_ODB 1)

        if(ODB_API_PATH)
            set(ODB_API_LIB_DIR ${ODB_API_PATH}/lib)
            set(ODB_API_BIN_DIR ${ODB_API_PATH}/bin)
        endif()

        add_definitions(-DMETVIEW_ODB_NEW -DMETVIEW_ODB)
        set(METVIEW_ODB_API_INCLUDE_DIRS ${ODB_API_INCLUDE_DIRS}
                                         ${ODB_API_INCLUDE_DIRS}/..
                                         ${ODB_API_INCLUDE_DIRS}/../eclib
                                         ${ODB_API_INCLUDE_DIRS}/../eclib/eclib
                                         ${ODB_API_INCLUDE_DIRS}/odblib
                                         ${ECKIT_INCLUDE_DIRS})
    else()
        if(ENABLE_MARS_ODB)
            ecbuild_critical("ENABLE_ODB was set, but ODB not found")
            set(ENABLE_MARS_ODB 0)
            set(METVIEW_MARS_ODB 0)
        endif()
    endif()

=== src/CMakeLists.txt ===

add_subdirectory( libMars )
add_subdirectory( libMvMacroApi )
add_subdirectory( libMetview )
add_subdirectory( libFTimeUtil )

#add_subdirectory( Datacoverage )
add_subdirectory( Divrot )
add_subdirectory( Ecfile )
add_subdirectory( Event )
add_subdirectory( Macro )
add_subdirectory( MvApp )
add_subdirectory( Flextra )
add_subdirectory( GribVectors )
add_subdirectory( Hovmoeller )
add_subdirectory( KML )
add_subdirectory( Met3D )
add_subdirectory( ObsFilter )
add_subdirectory( Percentile )
if (HAVE_FORTRAN)
    add_subdirectory( PottF )
    add_subdirectory( Spectra )
endif()
add_subdirectory( PythonServe )
add_subdirectory( Relhum )
add_subdirectory( Rttov )
add_subdirectory( Scm )
add_subdirectory( Stations )
add_subdirectory( StdAppManager )
add_subdirectory( Thermo )
add_subdirectory( Velstr )
add_subdirectory( Vapor )
add_subdirectory( XSection )

if(ENABLE_INPE)
    add_subdirectory(CptecAccess)
endif()

if(ENABLE_OPERA_RADAR)
    add_subdirectory(OperaRadar)
endif()

if(ENABLE_URL_DOWNLOAD)
    add_subdirectory(Download)
endif()

if(ENABLE_UI)
    add_subdirectory(libMvQtUtil)
    add_subdirectory(libMvQtGui)
    #add_subdirectory(libMvQtTextPager)
    add_subdirectory(AppMod)
    add_subdirectory(BufrExaminer)
    add_subdirectory(DebugTools)
    add_subdirectory(Eccharts)
    add_subdirectory(ExamineManager)
    add_subdirectory(FlextraExaminer)
    add_subdirectory(GeopExaminer)
    add_subdirectory(GribExaminer)
    add_subdirectory(MacroEditor)
    add_subdirectory(NcExaminer)
    add_subdirectory(OgcClient)
    add_subdirectory(ScmEditor)
 
    # omitted: VisTools


    if(ENABLE_EXPERIMENTAL)
        add_subdirectory(MarsCatalog)
    endif()

    add_subdirectory(Desktop)
endif()


if(ENABLE_PLOTTING)
    add_subdirectory(uPlot)
    add_subdirectory(MagML)
    add_subdirectory(Reprojection)

    if(AT_ECMWF)
        add_subdirectory(Meteogram)
    endif()
endif()


if(ENABLE_ODB)
    add_subdirectory(Odb)
    if(ENABLE_UI)
        add_subdirectory(OdbExaminer)
    endif()
endif()


# still to do:
#     ensure that contents of images directory are put into tarball

# will not do:  libMars-ecregrid Obstat ObstatCurveTool ObstatScatterTool

# propagate ModuleObjectSpecFiles to the parent scope so we can use it again
set(ModuleObjectSpecFiles ${ModuleObjectSpecFiles} PARENT_SCOPE)
set(ModuleXpmFiles        ${ModuleXpmFiles}        PARENT_SCOPE)
set(ModuleSvgFiles        ${ModuleSvgFiles}        PARENT_SCOPE)

=== src/BufrExaminer/CMakeLists.txt ===

set(BufrExaminer_moc
    BufrExaminer.h
    BufrCompDataWidget.h
    BufrFilterDialog.h
    BufrFilterEditor.h
   )

set(BufrExaminer_form
    BufrCompDataWidget.ui
    BufrFilterDialog.ui
    BufrKeyWidget.ui
   )

if(METVIEW_QT5)
 QT5_WRAP_CPP(BufrExaminer_MOC ${BufrExaminer_moc})
 QT5_WRAP_UI(BufrExaminer_FORMS_HEADERS ${BufrExaminer_form})
else()
 QT4_WRAP_CPP(BufrExaminer_MOC ${BufrExaminer_moc})
 QT4_WRAP_CPP(BufrExaminer_FORMS_HEADERS ${BufrExaminer_form})
endif()


ecbuild_add_executable( TARGET       BufrExaminer
                        SOURCES      MvMain.cc
                                     BufrCompDataWidget.cc                                     
                                     BufrExaminer.cc
                                     BufrFilterDialog.cc
                                     BufrFilterEditor.cc
                                     BufrKeyWidget.cc                                                                          
                                     MvQBufrDataItem.cc
                                     MvQBufrDataModel.cc
                                     BufrCompDataWidget.h
                                     BufrExaminer.h                                   
                                     BufrFilterDialog.h
                                     BufrFilterEditor.h
                                     BufrKeyWidget.h                                                                          
                                     MvQBufrDataItem.h
                                     MvQBufrDataModel.h
                                     ${BufrExaminer_MOC}
                                     ${BufrExaminer_FORMS_HEADERS}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}
                                     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

=== src/DebugTools/CMakeLists.txt ===

### TODO: bin/mvmon  bin/MvMonitor


if(METVIEW_QT5)
 QT5_WRAP_CPP(XServ_MOC XServ.h)
 QT5_ADD_RESOURCES(XServ_RES XServ.qrc)
else()
 QT4_WRAP_CPP(XServ_MOC XServ.h)
 QT4_ADD_RESOURCES(XServ_RES XServ.qrc)
endif()


set(xserv_srcs
    XServ.cc XServ.h  ${XServ_MOC} ${XServ_RES}
)


ecbuild_add_executable( TARGET       xserv
                        SOURCES      ${xserv_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${METVIEW_QT_LIBRARIES}
                    )


if(METVIEW_QT5)
 QT5_WRAP_CPP(MvMonitor_MOC ProcMonitor.h)
 QT5_ADD_RESOURCES(MvMonitor_RES debug.qrc)
else()
 QT4_WRAP_CPP(MvMonitor_MOC ProcMonitor.h)
 QT4_ADD_RESOURCES(MvMonitor_RES debug.qrc)
endif()

#message(STATUS "WRAP_CPP: ${MvMonitor_MOC}")
#message(STATUS "ADD_RES: ${MvMonitor_RES}")


set(MvMonitor_srcs
    MvMainMonitor.cc ProcMonitor.cc MvProcNode.cc MvQProcModel.cc
    MvProcNode.h MvQProcModel.h ${MvMonitor_MOC} ${MvMonitor_RES}
)


ecbuild_add_executable( TARGET       MvMonitor
                        SOURCES      ${MvMonitor_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

=== src/Desktop/CMakeLists.txt ===
set(desktop_qt_wrap_files                          
                         MvQAdvancedSearch.h
                         MvQBookmarks.h
                         MvQEditor.h
                         MvQFileBrowser.h
                         MvQDetailedFolderView.h
                         MvQIconMimeData.h
                         MvQColourGradLine.h
                         MvQColourListLine.h
                         MvQDrawerPanel.h
                         MvQEcLayerHelp.h
                         MvQEcLayerLine.h
                         MvQEcLayerTreeWidget.h
                         MvQEcStyleHelp.h
                         MvQEcStyleLine.h
                         MvQPathWidget.h
                         Runnable.h
                         MvQFileWatcher.h
                         MvQFind.h
                         MvQFolderDrawerPanel.h
                         MvQFolderHistory.h
                         MvQFolderPanel.h
                         MvQFolderWidget.h
                         MvQFolderModel.h
                         MvQIconFolderView.h
                         MvQFolderViewDelegate.h
                         MvQFolderWatcher.h
                         #MvQHelpBrowser.h
                         MvQListFolderViewBase.h
                         MvQNewIconWidget.h
                         MvQRequestPanelLine.h
                         MvQBoolLine.h
                         MvQColourLine.h
                         MvQComboBoxLine.h
                         MvQIconHolder.h
                         MvQIconLine.h
                         MvQScrolledTextLine.h
                         MvQSearchPanel.h
                         MvQStringLine.h
                         MvQTextLine.h
                         MvQRequestPanelHelp.h
                         MvQColourHelp.h
                         MvQListHelp.h
                         MvQIconHelp.h
                         MvQLogDialog.h
                         MvQPageView.h
                         MvQPaletteHelp.h
                         MvQPaletteLine.h
                         MvQProductBrowser.h
                         MvQRequestPanelWidget.h
                         MvQScriptHelp.h
                         MvQSliderLine.h
                         MvQStationsHelp.h
                         MvQStyleHelp.h
                         MvQStyleLine.h
                         MvQStyleTreeWidget.h
                         MvQTemplateDrawer.h
                         MvQTemporaryEditor.h
                         #MvQTools.h
                         MvQViewDrawer.h
                         ComputeEditor.h
                         ViewEditor.h
                         SimpleEditor.h
                         FamilyEditor.h
                         MacroParamEditor.h
                         Tools.h
                         Input.h
 )

if(METVIEW_QT5)
  QT5_WRAP_CPP(Desktop_MOC 
       ${desktop_qt_wrap_files}
  )
  QT5_ADD_RESOURCES(Desktop_RES desktop.qrc)
else()
  QT4_WRAP_CPP(Desktop_MOC 
       ${desktop_qt_wrap_files}
  )
  QT4_ADD_RESOURCES(Desktop_RES desktop.qrc)
endif()

set(desktop_srcs    MvMainQtBrowser.cc
                    MvQ.cc
                    MvQActionList.cc
                    MvQAdvancedSearch.cc
                    MvQBookmarks.cc
                    MvQBoolLine.cc
                    MvQColourHelp.cc
                    MvQColourLine.cc
                    MvQColourGradLine.cc
                    MvQColourListLine.cc
                    MvQComboBoxLine.cc
                    MvQContextMenu.cc
                    MvQDesktop.cc
                    MvQDesktopSettings.cc
                    MvQDetailedFolderView.cc
                    MvQDrawerPanel.cc
                    MvQDrawerView.cc
                    MvQEcLayerDb.cc
                    MvQEcLayerHelp.cc
                    MvQEcLayerLine.cc
                    MvQEcLayerTreeWidget.cc
                    MvQEcStyleHelp.cc
                    MvQEcStyleLine.cc
                    MvQEditor.cc
                    MvQExternalHelp.cc
                    MvQFileBrowser.cc
                    MvQFileWatcher.cc
                    MvQFind.cc
                    MvQFolderDrawerPanel.cc
                    MvQFolderHistory.cc
                    MvQFolderItemProperty.cc
                    MvQFolderModel.cc
                    MvQFolderNavigation.cc
                    MvQFolderPanel.cc
                    MvQFolderViewBase.cc
                    MvQFolderViewDelegate.cc
                    MvQFolderViewHandler.cc
                    MvQFolderWatcher.cc
                    MvQFolderWidget.cc
                    MvQGeoHelp.cc
                    #MvQHelpBrowser.cc
                    MvQIconFolderView.cc
                    MvQIconHelp.cc
                    MvQIconHelpView.cc
                    MvQIconHolder.cc
                    MvQIconLine.cc
                    MvQIconMimeData.cc
                    MvQIconObjectModel.cc
                    MvQIconProvider.cc
                    MvQIconStripView.cc
                    MvQListHelp.cc
                    MvQListFolderViewBase.cc
                    MvQLogDialog.cc
                    MvQMessageBox.cc
                    MvQNewIconWidget.cc
                    MvQNoneLine.cc
                    MvQPageView.cc
                    MvQPalette.cc
                    MvQPaletteDb.cc
                    MvQPaletteHelp.cc
                    MvQPaletteLine.cc
                    MvQPathWidget.cc
                    MvQProductBrowser.cc
                    MvQRecentIcons.cc
                    MvQRequestPanelHelp.cc
                    MvQRequestPanelLine.cc
                    MvQRequestPanelWidget.cc
                    MvQScriptHelp.cc
                    MvQScrolledTextLine.cc
                    MvQSearchPanel.cc
                    MvQSliderLine.cc
                    MvQStationsHelp.cc
                    MvQStringLine.cc
                    MvQStyleDb.cc
                    MvQStyleHelp.cc
                    MvQStyleLine.cc
                    MvQStyleTreeWidget.cc
                    MvQTemplateDrawer.cc
                    MvQTemporaryEditor.cc
                    MvQTextLine.cc
                    MvQTheme.cc
                    #MvQTools.cc
                    MvQViewDrawer.cc
                    Action.cc
                    ActionCommand.cc
                    Command.cc
                    ComputeEditor.cc
                    ConfigLoader.cc
                    Counted.cc
                    Dependancy.cc
                    Drop.cc
                    Editor.cc 
                    EditorDrawerFactory.cc
                    EditorFactory.cc
                    EditTransaction.cc
                    FamilyEditor.cc
                    FamilyObject.cc
                    FamilyScanner.cc
                    FileObject.cc
                    Folder.cc
                    FolderDatabase.cc
                    FolderInfo.cc
                    FolderSearchData.cc
                    FolderSettings.cc
                    HelpFactory.cc
                    IconClass.cc 
                    IconFactory.cc
                    IconGroupTools.cc
                    IconInfo.cc
                    IconObject.cc
                    Input.cc
                    InternalService.cc
                    InternalTask.cc
                    Items.cc
                    Language.cc
                    LineFactory.cc
                    Log.cc
                    MacroGuiObject.cc
                    MacroObject.cc
                    MacroParamEditor.cc
                    MacroParamObject.cc
                    MacroParamState.cc
                    MessageObserver.cc
                    MethodCommand.cc
                    MetviewService.cc
                    MetviewTask.cc
                    NoEditor.cc
                    Parameter.cc
                    Product.cc
                    ProductFolder.cc
                    Protocol.cc
                    Queue.cc
                    RequestPanel.cc
                    RequestPanelItem.cc
                    ReplyObserver.cc
                    ResolveTransaction.cc
                    RootFolder.cc
                    Runnable.cc
                    ShellService.cc
                    ShellTask.cc
                    Service.cc
                    ServiceEditor.cc
                    SimpleEditor.cc
                    StandardObject.cc
                    State.cc
                    SystemFolder.cc
                    Task.cc
                    TeeBuffer.cc
                    TeeStream.cc
                    TemporaryEditor.cc
                    TemporaryFolder.cc
                    TemporaryObject.cc
                    Tools.cc
                    Transaction.cc
                    ViewEditor.cc
                    Wastebasket.cc)



ecbuild_add_executable( TARGET       Desktop
                        SOURCES      ${desktop_srcs}
                                     ${Desktop_MOC}
                                     ${Desktop_RES}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${GDBM_LIB}
                    )

=== src/Divrot/CMakeLists.txt ===

set(Divrot_srcs
    Divrot.cc divrot-exFortran.cc Divrot.h
)

if(HAVE_PPROC_MIR)
    set(DIVROT_PPROC_MIR_DEF "HAVE_PPROC_MIR")
endif()

if(HAVE_PPROC_EMOS)
    set(DIVROT_PPROC_EMOS_DEF "HAVE_PPROC_EMOS")
endif()

ecbuild_add_executable( TARGET       Divrot
                        SOURCES      ${Divrot_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS} ${DIVROT_PPROC_MIR_DEF} ${DIVROT_PPROC_EMOS_DEF}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${MIR_INCLUDE_DIRS}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${LIBEMOS_LIBRARIES} ${METVIEW_EXTRA_LIBRARIES}
                    )

if(HAVE_PPROC_MIR)
    metview_module_files(ETC_FILES ObjectSpec.DivrotMir
                                   DivrotMirDef
                         SVG_FILES DIVROT_MIR.svg
                         )
endif()

=== src/Macro/CMakeLists.txt ===
# TODO: mvimportDesktop  perlaccess????


set(Macrolib_srcs
    value.cc code.cc variable.cc context.cc script.cc files.cc
    misc.cc number.cc stack.cc date.cc mstring.cc request.cc
    Unix.cc grib.cc mlist.cc module.cc remote.cc function.cc
    matrix.cc image.cc arith.cc extern.cc mvector.cc mtable.cc library.cc
    debug.cc bufr.cc compute.cc mgptset.cc vismod.cc macroy.c
    netcdf.cc object.cc pngjpeg.cc mflextra.cc python.cc
)


include_directories( include )  # relative to the current source directory


if( HAVE_PPROC_MIR )
    add_definitions( -DHAVE_PPROC_MIR )
    include_directories(${MIR_INCLUDE_DIRS})
endif()

if( HAVE_PPROC_EMOS )
    add_definitions( -DHAVE_PPROC_EMOS )
endif()

if( ENABLE_UI )
    add_definitions( -DENABLE_UI )
endif()

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/macrol.c
	COMMAND ${FLEX_EXECUTABLE} -l ${CMAKE_CURRENT_SOURCE_DIR}/macrol.l\; sed -e s/yy/zz/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/macrol.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macrol.l)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/macroy.c
	COMMAND ${BISON_EXECUTABLE} -y ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y\; sed -e s/yy/zz/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/macroy.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y ${CMAKE_CURRENT_BINARY_DIR}/macrol.c)

ADD_CUSTOM_TARGET(macrolex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/macroy.c ${CMAKE_CURRENT_BINARY_DIR}/macrol.c)



#set(Macro_libs ${STANDARD_METVIEW_LIBS_ODB} ${METVIEW_EXTRA_LIBRARIES})

if(ENABLE_ODB)
    list(APPEND Macrolib_srcs codb.cc)
    list(APPEND Macro_libs ${METVIEW_ODB_API_LIBRARIES})
endif()


ecbuild_append_to_rpath("../lib") # so that libMvMacro can find libMvUtil, etc
ecbuild_add_library( TARGET           MvMacro
					 TYPE             SHARED
					 SOURCES          ${Macrolib_srcs}
					 TEMPLATES        ${common_templates}
					 DEFINITIONS      ${METVIEW_EXTRA_DEFINITIONS}
					 PRIVATE_INCLUDES ${METVIEW_STANDARD_INCLUDES}
					 LIBS             ${Macro_libs} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES}
					)

set(link_libs MvMacro Metview MvMars)
if (HAVE_FORTRAN)
    list(APPEND link_libs macro_api_f90)
endif()

#target_link_libraries(link_libs)


#target_link_libraries(MvMacro
#	 ${Macro_libs} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES}
#	"-Wl,--whole-archive"
##    app models
##    "-Wl,--no-whole-archive"
#)
# GIVES THE FOLLOWING ERROR:
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS): In function `_ZGVbN2v___log_finite':
#/home/abuild/rpmbuild/BUILD/glibc-2.22/mathvec/../sysdeps/x86_64/fpu/svml_finite_alias.S:31: multiple definition of `_ZGVbN2v___log_finite'
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS):/home/abuild/rpmbuild/BUILD/glibc-2.22/mathvec/../sysdeps/x86_64/fpu/svml_finite_alias.S:31: first defined here
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS): In function `_ZGVcN4v___log_finite':


ecbuild_add_executable( TARGET       macro
                        SOURCES      main.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${link_libs} #MvMacro
                    )

#ecbuild_add_executable( TARGET       pytest
#						SOURCES      python.cc
#						DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
#						LIBS         ${link_libs} MvMacro
#					)


ADD_DEPENDENCIES(macro macrolex)


######################################################################################

# PROBLEM getting CMake to accept the arguments to 'sed'. One possibility would be to
# put this into a separate script; another would be to simply put the beau.h file
# directly into the repository and skip the step of generating it.

#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beaul.c
#	COMMAND lex -l ${CMAKE_CURRENT_SOURCE_DIR}/beaul.l\; sed -e s/yy/zz/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/beaul.c
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/beaul.l)
#
#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beauy.c
#	COMMAND yacc -t ${CMAKE_CURRENT_SOURCE_DIR}/beauy.y\; sed -e s/yy/zz/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/beauy.c
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y)
#
#set(BS \\)
##	COMMAND sed -e 's/\\(.*\\)/\\"\\1\\",/' < ${CMAKE_CURRENT_SOURCE_DIR}/beau.ps > ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#	COMMAND sed -e 's/${BS}(.*${BS})/${BS}\"${BS}1\",/' < ${CMAKE_CURRENT_SOURCE_DIR}/beau.ps > ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/beauy.y)
#
#
#ADD_CUSTOM_TARGET(beaulex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/beauy.c ${CMAKE_CURRENT_BINARY_DIR}/beaul.c ${CMAKE_CURRENT_BINARY_DIR}/beau.h)
#
#
#ecbuild_add_executable( TARGET       beautify
#                        SOURCES      beauy.y beautify.c 
#                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
#                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR}
#                        LIBS         ${Macro_libs}
#                    )
#
#ADD_DEPENDENCIES(beautify beaulex)


######################################################################################


set(mvimport_srcs
    mvimport.c
)

ecbuild_add_executable( TARGET       mvimport
                        SOURCES      ${mvimport_srcs}
                        DEFINITIONS
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )


######################################################################################


set(mvimportDesktop_srcs
    mvimportDesktop.c
)

ecbuild_add_executable( TARGET       mvimportDesktop
                        SOURCES      ${mvimportDesktop_srcs}
                        DEFINITIONS
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

=== src/MacroEditor/CMakeLists.txt ===

if(METVIEW_QT5)
 QT5_WRAP_CPP      (MacroEd_MOC MvMain.h FindTextDialog.h Highlighter.h MacroEdit.h FunctionListDialog.h mvplaintextedit.h
                   CodeTemplateDialog.h GotoLineDialog.h RunDialog.h TabsDialog.h VerbFunctionHelpDialog.h MacroEdit.h)
 QT5_ADD_RESOURCES (MacroEd_RES MacroEdit.qrc)
 QT5_WRAP_UI       (MacroEd_FORMS_HEADERS CodeTemplateDialog.ui FunctionListDialog.ui VerbFunctionHelpDialog.ui
                   FindTextDialog.ui MacroEdit.ui GotoLineDialog.ui RunDialog.ui TabsDialog.ui)
else()
 QT4_WRAP_CPP      (MacroEd_MOC MvMain.h FindTextDialog.h Highlighter.h MacroEdit.h FunctionListDialog.h mvplaintextedit.h
                   CodeTemplateDialog.h GotoLineDialog.h RunDialog.h TabsDialog.h VerbFunctionHelpDialog.h MacroEdit.h)
 QT4_ADD_RESOURCES (MacroEd_RES MacroEdit.qrc)
 QT4_WRAP_UI       (MacroEd_FORMS_HEADERS CodeTemplateDialog.ui FunctionListDialog.ui VerbFunctionHelpDialog.ui
                   FindTextDialog.ui MacroEdit.ui GotoLineDialog.ui RunDialog.ui TabsDialog.ui)
endif()

set(macroeditor_srcs MvMain.cc
                     Highlighter.cc
                     MacroEdit.cc
                     CodeTemplateDialog.cc
                     EditorTheme.cc
                     FindTextDialog.cc
                     GotoLineDialog.cc
                     RunDialog.cc
                     TabsDialog.cc
                     FunctionListDialog.cc
                     VerbFunctionHelpDialog.cc
                     mvplaintextedit.cc
                     MacroHelper.cc
                     MagMLHelper.cc
                     ShellHelper.cc
                     PlainTextHelper.cc
                     PythonHelper.cc
                     LanguageHelper.cc
                     LanguageHelperFactory.cc
                     VerbFunctionHelp.cc
                     CodeTemplateDialog.h
                     EditorTheme.h
                     FindTextDialog.h
                     FunctionListDialog.h
                     GotoLineDialog.h
                     Highlighter.h
                     LanguageHelper.h
                     LanguageHelperFactory.h
                     MacroEdit.h
                     MacroHelper.h
                     MagMLHelper.h
                     ShellHelper.h
                     MvMain.h
                     PlainTextHelper.h
                     RunDialog.h
                     MacroRunOptions.h
                     TabsDialog.h
                     TabsSettings.h
                     VerbFunctionHelp.h
                     VerbFunctionHelpDialog.h
                     mvplaintextedit.h)

#include_directories( CMAKE_CURRENT_BINARY_DIR . )

ecbuild_add_executable( TARGET       MacroEditor
                        SOURCES      ${MacroEd_FORMS_HEADERS}
                                     ${MacroEd_MOC}
                                     ${MacroEd_RES}
                                     ${macroeditor_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}
                                     ${METVIEW_STANDARD_INCLUDES} ${X11_INCLUDE_DIR} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${X11_LIBRARIES}
                    )

=== src/MarsCatalog/CMakeLists.txt ===
if(METVIEW_QT5)
 QT5_WRAP_CPP(MarsCat_MOC MvQMarsBrowser.h MvQMarsCatalog.h)
 QT5_ADD_RESOURCES(MarsCat_RES mars.qrc)
else()
 QT4_WRAP_CPP(MarsCat_MOC MvQMarsBrowser.h MvQMarsCatalog.h)
 QT4_ADD_RESOURCES(MarsCat_RES mars.qrc)
endif()

set(mars_cat_srcs
    MvMain.cc
    MvQMarsBrowser.cc
    MvQMarsCatalog.cc
    json_spirit_reader.cpp
    json_spirit_value.cpp
    json_spirit_writer.cpp
    json_spirit.h
    MvQMarsBrowser.h
    MvQMarsCatalog.h
    json_spirit_reader.h
    json_spirit_value.h
    json_spirit_writer.h)


ecbuild_add_executable( TARGET       MarsCatalogue
                        SOURCES      ${mars_cat_srcs} ${MarsCat_MOC} ${MarsCat_RES}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

#metview_module_files(ETC_FILES ObjectSpec.MarsCatalog
#                     XPM_FILES MARS_CATALOG.xpm)

# XXX in the future we may need to distribute the WebMars directory as well

=== src/MvApp/CMakeLists.txt ===


ecbuild_add_executable( TARGET       pool
                        SOURCES      pool.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${LIBEMOS_LIBRARIES}
                    )


if ( NOT FDB_FOUND )
add_definitions(-DNOFDB)
endif()

ecbuild_add_executable( TARGET       Mars
                        SOURCES      MarsG2.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${ODB_API_INCLUDE_DIRS} ${FDB_INCLUDE_DIRS}
                        LIBS         ${STANDARD_METVIEW_LIBS_ODB} ${LIBEMOS_LIBRARIES} ${FDB_LIBRARIES} ${METVIEW_ODB_API_LIBRARIES}
                    )

ecbuild_add_executable( TARGET       togrib
                        SOURCES      togrib.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

ecbuild_add_executable( TARGET       tomatrix
                        SOURCES      tomatrix.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

ecbuild_add_executable( TARGET       geo_to_grib
                        SOURCES      geo_to_grib.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

ecbuild_add_executable( TARGET       grib_to_geo
                        SOURCES      grib_to_geo.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )


if (METVIEW_MARS_ODB)
    metview_module_files(ETC_FILES ObjectSpec.MarsOdb
                               
                         XPM_FILES ODB_MARS.xpm
                        )
endif()

if(HAVE_PPROC_MIR)
    metview_module_files(ETC_FILES ObjectSpec.MarsMir
                         SVG_FILES READ_MIR.svg RETRIEVE_MIR.svg
                         )
endif()

=== src/ObsFilter/CMakeLists.txt ===

ecbuild_add_executable( TARGET       ObsFilter
                        SOURCES      ObsFilter.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${LIBEMOS_LIBRARIES}
                    )

ecbuild_add_executable( TARGET       CleanFile
                        SOURCES      CleanFile.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${LIBEMOS_LIBRARIES}
                    )

ecbuild_add_executable( TARGET       BufrPicker
                        SOURCES      BufrPicker.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${LIBEMOS_LIBRARIES}
                    )


ecbuild_add_executable( TARGET       BufrFilter
                            SOURCES      BufrFilter.cc
                            DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                            INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                            LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${LIBEMOS_LIBRARIES}
                          )


metview_module_files(ETC_FILES  ObjectSpec.BufrPicker BufrPickerDef BufrPickerRules)

metview_module_files(ETC_FILES  ObjectSpec.BufrFilter BufrFilterDef BufrFilterRules)

=== src/PottF/CMakeLists.txt ===

# we need to make sure these come before anything like /usr/incliude so we get the right .mod file
include_directories(BEFORE   ${CMAKE_CURRENT_BINARY_DIR} ${METVIEW_STANDARD_INCLUDES})

ecbuild_add_executable( TARGET       PottF
                        SOURCES      PottF.cc pott.F eqpott.F seqpott.F tlvalid.F pml.F sshm.F
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        #INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_MACRO_API_F90_LIB} ${METVIEW_MACRO_API_C_LIB} ${STANDARD_METVIEW_LIBS} ${GRIB_API_LIBRARIES}
                    )

metview_module_files(ETC_FILES  ObjectSpec.PottF PottFDef PottFRules)

=== debian/changelog ===
metview (5.3.0-3ubuntu2) eoan; urgency=medium

  * Fixup another issue in includes
  * Cherry-pick upstream fix for build

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 07 Aug 2019 17:13:08 +0200

metview (5.3.0-3) unstable; urgency=medium

  * Standards-Version: 4.4.0
  * Use ACCEPT_USE_OF_DEPRECATED_PROJ_API_H to build with Proj6.
    Closes: #931945
  * Now use g++14 std to compile
  * Enforce use of c++14 std when compiling in d/rules
  * Use debhelper 12

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 18 Jul 2019 15:30:29 +0100

metview (5.3.0-2) unstable; urgency=medium

  * Check correct $(MMODDIR) for grib_api.mod. Closes: #923453
  * Standards-Version: 4.3.0
  * Link against libeckit, no longer automatically linked by-odb-api.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Feb 2019 15:32:29 +0000

metview (5.3.0-1) unstable; urgency=medium

  * New upstream release
  * Add -I $(FMODDIR) to look for Fortran mod files

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 21 Dec 2018 10:29:51 +0000

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 12), 
  gfortran, 
  flex, 
  bison, 
  libhdf5-dev, 
  libpango1.0-dev, 
  libfftw3-dev,
  chrpath, 
  mksh,
  libqt5webkit5-dev (>= 5.212.0~alpha2-15), 
  qtbase5-dev, libqt5xmlpatterns5-dev,
  libeccodes-dev (>= 2.2.0),
  libeccodes-tools,
  libodb-api-dev (>= 0.18.0-5),
  libemos-dev (>= 2:4.1.1-2),  libemos-bin,
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev, 
  libmagics++-dev (>= 2.34.3-3),
  libxmu-dev, libgdbm-dev, 
  libcurl4-gnutls-dev,
  libcairo2-dev, 
  pkg-config,
  swig, 
  libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libproj-dev, libqt5svg5-dev,
  libgd-dev, 
  imagemagick, 
  libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  cmake, 
  flextra, 
  libgeotiff-dev
Standards-Version: 4.4.0
Homepage: https://software.ecmwf.int/wiki/display/METV/Metview
Vcs-Browser: https://salsa.debian.org:/science-team/metview.git
Vcs-Git: https://salsa.debian.org:/science-team/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetview0d (=${binary:Version}),
 x11-utils, metview-data, python3
Recommends: magics++
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview0d
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Shared libraries  for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides shared libraries and  for  Metview-based software.

Package: libmetview-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmetview0d (=${binary:Version})
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# Workaround for proj_api.h deprecation in PROJ 6.0.0
export DEB_CFLAGS_MAINT_APPEND=-DACCEPT_USE_OF_DEPRECATED_PROJ_API_H
export DEB_CXXFLAGS_MAINT_APPEND=-DACCEPT_USE_OF_DEPRECATED_PROJ_API_H

# DEB_LDFLAGS_MAINT_PREPEND:= -Wl,-z,defs -Wl,--as-needed
DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-format
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
export DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_PREPEND
export QT_SELECT=5
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) -std=gnu++14
UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')

# Needed for sbuild. metview creates temp directories during build
export HOME:=/tmp
export METVIEW_LOCALHOST:=127.0.0.1
export METVIEW_DEBUG:=1
export FC:=$(shell basename $(shell readlink -f /usr/bin/f95))

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_CPU)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
PATH:=$(PATH):$(CURDIR)/scripts
AUTOGENERATED:= libmetview-dev.install  metview.install libmetview0d.install libmetview0d.links
MV_DIR:=/usr/lib/$(DEB_HOST_MULTIARCH)/metview
export METVIEW_DIR_DEV:=$(CURDIR)/debian/build
export METVIEW_BIN:=$(METVIEW_DIR_DEV)/bin


# Hack until complter  uses this directory
FMODDIR:=$(LIBDIR)/fortran/$(FC)
FCFLAGS:=$(shell dpkg-buildflags --get FCFLAGS) -I $(FMODDIR)

LC_ALL=C
TZ=UTC+0
export LC_ALL TZ

FPIC:= ''
ifeq ($(TARGET_ARCH), i386)
	FPIC:= -fPIC
endif

# magic debhelper rule
%:
	dh $@ --buildsystem=cmake --builddirectory=$(METVIEW_DIR_DEV) 

override_dh_auto_clean:
	dh_clean
	rm -rf $(METVIEW_DIR_DEV) src/images/metview.png
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	[ ! -f scripts/metview_base.in.bak ] || \
		( mv scripts/metview_base.in.bak scripts/metview_base.in )

# magics++ upstream ships with a copy of terralib, which is not used in Debian. 
# Instead we use # a shared terralib library, and so need to include terralib.
# Also -fPIC, for some reason.

override_dh_auto_configure:
	chmod +x ./scripts/*.mv
	# Hack. how to do this via ecbuild?
	cp scripts/metview_base.in scripts/metview_base.in.bak
	sed -e 's%@DEB_HOST_MULTIARCH@%${DEB_HOST_MULTIARCH}%g' < scripts/metview_base.in \
		> scripts/tmpx && mv scripts/tmpx scripts/metview_base.in
	dh_auto_configure -- \
		-DCMAKE_CXX_STANDARD=14 \
		-DCMAKE_CXX_STANDARD_REQUIRED=On \
		-DMETVIEW_SITE=debian  \
		-DCMAKE_BUILD_TYPE=Release \
		-DMETVIEW_EXTRA_LIBRARIES='terralib -lemosR64 -leccodes -leckit' \
		-DMETVIEW_EXTRA_INCLUDE_DIRS='/usr/include/terralib/kernel' \
		-DMAGICS_HAVE_METVIEW=True \
		-DMAGICS_HAVE_NETCDF=True \
		-DMAGICS_PATH=/usr \
		-DBUILD_SHARED_LIBS=On \
		-DSKIP_INSTALL_RPATHS=On \
		-DENABLE_RPATHS=Off \
		-DENABLE_RELATIVE_RPATHS=Off \
		-DENABLE_ODB=On \
		-DODB_PATH=/usr \
		-Dodb_api_DIR=${LIBDIR}/cmake/odb_api \
		-DFLEXTRA_PATH=/usr/bin/flextra \
		-DDISABLE_OS_CHECK=On \
		-DCMAKE_Fortran_FLAGS=$(FCFLAGS) \
		-DFPIC=${FPIC} \
		-DCMAKE_Fortran_FLAGS='$(FCFLAGS)' 
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g'  < debian/CONFIG.site.in  | \
		sed -e 's%@UPSTREAM_VERSION@%${UPSTREAM_VERSION}%g' | \
		> $(METVIEW_DIR_DEV)/scripts/CONFIG.site 
	# These get generated ok on a machine with network connection, but fail on sbuilds, etc.
	# so copy pre-generated versions stored in etc
	mkdir -p debian/build/share/metview/etc/
	cp debian/etc/* debian/build/share/metview/etc/
	cd debian/build/share/metview/etc && $(MAKE) ObjectListAllTarget
	cp src/images/metview_logo.png src/images/metview.png

override_dh_auto_test:
	@echo "Checks disabled for the moment due to syntax errors in tests" 

override_dh_fixperms-arch:
	dh_fixperms
	rm -f debian/metview/usr/lib/*/metvidew/metview_post_install_tests.sh
	chmod 755 debian/metview/$(MV_DIR)/mv_compress
	chmod 644 debian/metview/$(MV_DIR)/metview_*.common
	chmod 644 debian/metview/$(MV_DIR)/metview_stat
	chmod 644 debian/metview/$(MV_DIR)/metview_patches
	chmod 644 debian/metview/usr/share/images/metview/*
	file debian/metview/$(MV_DIR)/* | grep ELF | cut -f1 -d: | xargs chrpath -d
	chrpath -d debian/libmetview0d/usr/lib/*/lib*so.0.0.0

override_dh_fixperms-indep:
	dh_fixperms
	rm -rf debian/metview-data/usr/share/applications
	find debian/metview-data/usr/share/metview -type f -exec chmod 644 {} \;
	find debian/metview-data/usr/share/metview -type d -exec chmod 755 {} \; 
	# Hack. Why weren't these already compressed -n ?
	gunzip debian/metview-data/usr/share/metview/app-defaults/Sample_Drawers.tar.gz
	gunzip debian/metview-data/usr/share/metview/app-defaults/User_Dir_Frame.tar.gz
	gzip -n debian/metview-data/usr/share/metview/app-defaults/Sample_Drawers.tar
	gzip -n debian/metview-data/usr/share/metview/app-defaults/User_Dir_Frame.tar
